#lang errortrace racket
#|

def join(sep, l):
  if l == []:
    return ""
  accum = l[0]
  l = l[1:]
  for x in l:
    accum = accum + sep + x
  return accum

l = ["x", "y", "z"]

|#

(define sep " * ")
(define (join sep l)
  (define (join-iter l accum)
    (cond [(empty? l) accum]
          [else
            (define x (first l))
            (join-iter (rest l) (string-append accum sep x))])) ; accum + sep + x
  (cond [(empty? l) ""]
        [else (join-iter (rest l) (first l))]))
;

(require rackunit)
(check-equal? (join ", " '("x" "y" "z")) "x, y, z")
(check-equal? (join ", " '()) "")
(check-equal? (join ", " '("x")) "x")


(define curried1
  (lambda (x)
    (lambda (y)
      (lambda (z)
        (+ x y z)))))

(define f (uncurry curried1))

;; (define (f x y z)
;;   (+ x y z))

; (((curried1 1) 2) 3)

; (f (list 1 2 3))

;; (define c1 (curried1 1))
;; (define c2 (c1 2))
;; (define c3 (c2 3))
;; c3







